//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  calculate (3)
//
//  Roger Apery ̌ɂ
//
//  (3)=5/2(-1)^(n-1)/(n^3*C(2n,n))
//
//    C(2n,n)=(2n)!/(n!*n!)
//

#include "Fint.hpp"

Fint zeta3(int precision)
{
  precision=GetPrecision()>precision ? GetPrecision():precision ;

  Fint zt(precision+1,precision),
       c5(precision+1,precision) ;
  zt=0 ;
  c5=5 ;
  Mint cb(1) ;
  Mint n(0) ;
  Fint w ;
  do {
    n++ ;
    cb = (2*cb*(2*n-1))/n ;
    w=c5/(2*cb*n*n*n) ;
    zt += w ;
    n++ ;
    cb = (2*cb*(2*n-1))/n ;
    w=c5/(2*cb*n*n*n) ;
    zt -= w ;
  } while( w!=0 ) ;

  return zt ;
}


Fint zeta32(int precision)
{
  precision=GetPrecision()>precision ? GetPrecision():precision ;

  Fint zt(precision+1,precision),
       c5(precision+1,precision) ;

  Mint cb(1) ;
  Mint a ;
  Fint w ;
  Mint c,cc(1) ;
  Fint e(1) ;
  Mint d(24*8*27*8) ;
  unsigned long n(0) ;
  zt=12463UL ;
  zt/=d ;
//  zt=0 ;
cout << endl << "zt " << zt ;
  do {
//    n++ ;
//    n-- ;
    c=2*n+2 ;
    c*=2*n+3 ;
    c*=2*n+1 ;
    c*=2*n+2 ;
    c*=n+1 ;
    cc*=power(c,3) ;
    c=3*n+3 ;
    c*=3*n+4 ;
    c*=3*n+5 ;
    c*=4*n+4 ;
    c*=4*n+5 ;
    c*=4*n+6 ;
    c*=4*n+7 ;
    d*=power(c,3) ;
    n++ ;
    ((((((((((a=126392UL)*=n)+=412708UL)*=n)+=531578UL)*=n)+=33637UL)*=n)+=104000UL)*=n)+=12463UL ;
    e=a*cc ;
//cout << endl << "a " << a ;
//cout << endl << "e " << e ;
//cout << endl << "d " << d ;
    w=e/d ;
//    n++ ;
    if( n&1 ) zt-=w ;
    else      zt+=w ;
cout << endl << zt ;
cout << endl << w ;
  } while( w!=0 ) ;

  return zt>>1 ;
}

