//
//  Copyright (C) by S.Tomabechi 1993,1996,2000 Ver 1.2
//  All rithts reserved.
//
//  Stop Watch
//

#include "CPUTime.hpp"

#ifdef WIN32
#include <Windows.h>
#endif

#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include <ctype.h>
#include <time.h>

#ifndef WIN32                // for Linux
double GetTickCount(void)
{
  return time(NULL)*1000.0 ;
}
#endif

#if 1
void CPUTime::Start(void) { StartTime=GetTickCount(); }
void CPUTime::Stop(void)  { Duration+=(GetTickCount()-StartTime) ; }
#else
void CPUTime::Start(void) { (StartTime=time(NULL))*=1000.0 ; }
void CPUTime::Stop(void)  { (Duration+=(time(NULL)-StartTime/1000.0))*=1000.0 ; }
#endif

::ostream& operator<<(::ostream& os,CPUTime& cputime)
{
  return os <<  cputime.hour()
      << ':' << setw(2) << setfill('0') << cputime.minutes()
      << ':' << setw(2) << setfill('0') << cputime.second()
      << ':' << setw(2) << setfill('0') << cputime.hundredths() ;
}


// istream >> "1:23:45:67" ;
istream& operator>>(istream& is,CPUTime& cputime)
{
  char str[8] ;

  int c ;
  double dur(0.0) ;
  int j,k ;
  unsigned long multiplier[]={3600000,60000,1000,100} ;
  for(;;) {
    c=is.get() ;
    if( is.eof() ) break ;
    if( isdigit(c) ) break ;
  }
  is.putback(char(c)) ;

  for( k=0 ; k<4 ; k++ ) {
    for( j=0 ;;) {
      c=is.get() ;
      if( is.eof() ) break ;
      if( !isdigit(c) ) { str[j++]='\0' ; break ; }
      else str[j++]=(char)c ;
    }
    dur+=double(atol(str))*multiplier[k] ;
  }

  cputime.Duration+=dur ;

  return is ;

}
