//
//  Copyright (C) by S.Tomabechi 1993,1994,1995,1997
//  All rights reserved.
//
//  Mint/Mint as integers
//
//  use Mint::_uMtemp and Mint::_vMtemp as temporary variable
//
//  dx̃[NbhZ ߂
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "Error.hpp"

Mint& Mint::isDiv(const Mint& a,const Mint& b)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif
  int anDigit=a.nDigit ;
  int bnDigit=b.nDigit ;
                              // b==0 ?
  if( bnDigit==0 ) Error(zero divide) ;

                              // abs(a)<abs(b) ?
  if( anDigit<bnDigit ) {
    __asm {
      mov edi,this
#ifdef __BORLANDC__
      mov dword ptr [edi].nDigit,0
      mov byte ptr [edi].nDim[3],1
#else
      mov dword ptr [edi][NDIGIT],0
      mov byte ptr [edi][SIGN],1
#endif
    }
    return *this ;
  }

                   // bPxȂȉ̃ASY͓KpłȂ̂,
                   // Pxp̊֐ŏ
  if( bnDigit==1 ) {
    isDivUL(a,(unsigned long)b) ;
    if( b.isNegative() ) {
      __asm {
        mov edi,this                    // 𔽓]
#ifdef __BORLANDC__
        neg  byte ptr [edi].nDim[3]
#else
        neg  byte ptr [edi][SIGN]
#endif
      }
    }
    return *this ;
  }

  int shift(31) ;
  signed char bSign,qSign ;
  unsigned long q,res ;
//  unsigned long d ;
  unsigned long v1,v2 ;
  unsigned long j ;
  unsigned long j_n4 ;
  int Count ;
  unsigned long ui,vi,ti ;
  int qnDigit=anDigit-bnDigit+1 ;

  if( Mint::_uMtemp.ndim()<=anDigit ) Mint::_uMtemp.allocate(anDigit+1) ;
  if( Mint::_vMtemp.ndim()< bnDigit ) Mint::_vMtemp.allocate(bnDigit) ;
  if( ndim()<qnDigit ) allocate(qnDigit) ;

#ifndef __BORLANDC__
   // VC++ ł CCAZuŃNX static o
   // ANZXłȂ
  unsigned long* uptr=Mint::_uMtemp.digit ;
  unsigned long* vptr=Mint::_vMtemp.digit ;
#endif


D1:
  __asm {
#ifdef __BORLANDC__
    mov   esi,this
    mov   esi,dword ptr [esi].digit
    mov   ti,esi
    mov   esi,dword ptr [@Mint@_vMtemp].digit
    mov   edi,dword ptr [@Mint@_uMtemp].digit
#else
    mov   esi,this
    mov   esi,dword ptr [esi][DIGIT]
    mov   ti,esi
    mov   esi,vptr
    mov   edi,uptr
#endif
    mov   ui,edi   // xAhXƂ蒼ׂ͕̂ɂȂ̂
    mov   vi,esi   // CfbNXWX^oĂ

    mov   ebx,bnDigit     // v̌

    mov   edi,b
#ifdef __BORLANDC__
    mov   al,byte ptr [edi].nDim[3]
    mov   edi,dword ptr [edi].digit
#else
    mov   al,byte ptr [edi][SIGN]
    mov   edi,dword ptr [edi][DIGIT]
#endif
    mov  bSign,al
                 //  傫邽߂̏搔 d=2^shift ߂
    bsr   ecx,dword ptr [ebx*NBYTE][edi][-NBYTE]
    sub   shift,ecx
    mov   ecx,shift

    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
  }
mult_vd:                          // _vMtemp=b<<shift
  __asm {
    dec   ebx
    jz    EXIT1
    mov   edx,eax
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
    shld  edx,eax,cl
    mov   dword ptr [esi][ebx*NBYTE],edx
    jmp   mult_vd
  }
EXIT1:
  __asm {
    shl   eax,cl
    mov   dword ptr [esi],eax


    mov   edi,a
#ifdef __BORLANDC__
    mov   al,byte ptr [edi].nDim[3]
    mov   edi,dword ptr [edi].digit
#else
    mov   al,byte ptr [edi][SIGN]
    mov   edi,dword ptr [edi][DIGIT]
#endif
    imul  bSign
    mov   qSign,al
    mov   esi,ui

    mov   ebx,anDigit               // a ̌
    xor   edx,edx
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
    shld  edx,eax,cl
    mov   dword ptr [esi][ebx*NBYTE],edx
  }
mult_ud:                           // r=u<<shift
  __asm {
    dec   ebx
    jz    EXIT2
    mov   edx,eax
    mov   eax,dword ptr [edi][ebx*NBYTE][-NBYTE]
    shld  edx,eax,cl
    mov   dword ptr [esi][ebx*NBYTE],edx
    jmp   mult_ud
  }
EXIT2:
  __asm {
    shl   eax,cl
    mov   dword ptr [esi],eax
  }
D2:
  __asm {                         // 
    mov   ebx,bnDigit
    mov   edi,vi         // v  AhX
    mov   eax,dword ptr [ebx*NBYTE][edi][-NBYTE]
    mov   v1,eax         // v̍ŏʌ
    mov   eax,dword ptr [ebx*NBYTE][edi][-2*NBYTE]
    mov   v2,eax         // v̎̌

    mov   eax,anDigit    // ǔ
    mov   j,eax          // j ̓JE^
    sub   eax,ebx
    shl   eax,2
    mov   j_n4,eax

    add   ti,eax
  }

D3:                      // ߂
  __asm {
    mov   ebx,j
    mov   esi,ui
    mov   edx,dword ptr [ebx*NBYTE][esi]   // dx=u[j]
    cmp   edx,v1
    jne   not_equal
    mov   eax,0ffffffffh          // u[j]==v1
    mov   q,eax
    mov   ecx,dword ptr [ebx*NBYTE][esi][-NBYTE]
  }
test0:
  __asm {
    add   ecx,v1
    jc    D4
    mov   res,ecx
    jmp   test1
  }
not_equal:
  __asm {
    mov   eax,dword ptr [ebx*NBYTE][esi][-NBYTE]
    div   v1
    mov   q,eax     // q=
    mov   res,edx   // res=]
  }
test1:
  __asm {
    mov   eax,v2
    mul   q
    mov   ecx,dword ptr [ebx*NBYTE][esi][-2*NBYTE]
    sub   ecx,eax
    mov   ecx,res
    sbb   ecx,edx
    jnc   D4
  }
q_1:
  __asm {            // 傫߂
    dec   q          //  1 炷
    jmp   test0
  }
D4:
  __asm {            // u-=q*v vZ
    mov   edi,vi
    mov   ecx,bnDigit
    add   esi,j_n4
    mov   Count,ecx
    xor   ecx,ecx    // ecx=Overflow
    mov   ebx,ecx    // ebx=carry
  }
mult:
  __asm {

    mov   eax,dword ptr [edi]
    lea   edi,[edi][NBYTE]
    mul   q
    add   eax,ecx
    adc   edx,0
    mov   ecx,edx    // ӂZ[u
  }
next1:
  __asm {
    add   eax,ebx
    adc   ecx,0
    sbb   dword ptr [esi],eax
    mov   ebx,0
    adc   ebx,0
    lea   esi,[esi][NBYTE]
    dec   Count
    jnz   mult
    mov   eax,ecx
    mov   ecx,0
    add   eax,ebx
    adc   ecx,0
    sbb   dword ptr [esi],eax
    adc   ecx,0
  }
D5:
  __asm {
    mov   edi,ti
    mov   eax,q
    mov   dword ptr [edi],eax
    jecxz D7
  }
D6:
  __asm {             // ߂̂ŉ߂
    dec   dword ptr [edi]
    mov   ecx,bnDigit
    mov   edi,vi
    mov   esi,ui
    add   esi,j_n4
    xor   ebx,ebx             // NAƂƂ,ӂ(clc)
  }
loop3:
  __asm {
    mov   eax,dword ptr [ebx*NBYTE][edi]
    adc   dword ptr [ebx*NBYTE][esi],eax
    inc   ebx
    dec   ecx
    jnz   loop3
    adc   dword ptr [ebx*NBYTE][esi],0
  }
D7:
  __asm {
//    cmp   j_n4,0
//    jle   D8
    sub   j_n4,NBYTE
    jc    D8
    dec   j
    sub   ti,NBYTE
    jmp   D3
  }
D8:
  __asm {

    mov   edi,this
#ifdef __BORLANDC__
    mov   esi,dword ptr [edi].digit
#else
    mov   esi,dword ptr [edi][DIGIT]
#endif
    mov   cl,qSign
    mov   ebx,qnDigit
    xor   eax,eax
  }
Search_nonZero:                   // ̃`FbN
  __asm {
//    cmp   dword ptr [ebx*NBYTE][esi][-NBYTE],0
    cmp   dword ptr [ebx*NBYTE][esi][-NBYTE],eax
    jne   nonZero
    dec   ebx
    jnz   Search_nonZero
    mov   cl,1
  }
nonZero:
  __asm {
#ifdef __BORLANDC__
    mov   dword ptr [edi].nDigit,ebx
    mov   byte ptr [edi].nDim[3],cl
#else
    mov   dword ptr [edi][NDIGIT],ebx
    mov   byte ptr [edi][SIGN],cl
#endif
  }

RET1:
#ifdef _MEMMAN_DEBUG
//_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif

  return *this ;
}

