//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  Euler's totient function
//    #{ k | gcd(k,n)=1 }
//
//  Euler ̊֐
//    :   n  ݂ɑf 1 ȏ n ȉ̐̌
//    : 2^32 菬ɂėL
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "IntFuncs.hpp"

unsigned long eulerphi(const unsigned long n)
{
  unsigned long phi(1),p ;

DO:
  p=prmdiv(n) ;            // find the smallest divisor
  __asm {
    mov ebx,p
    mov ecx,phi
    cmp ebx,1              // n is prime
    jnz MORE
    mov ebx,n
    dec ebx                // n-1
    mov eax,ecx            // eax <- phi
    mul ebx                // phi *= n-1
    mov phi,eax
    jmp END
  }
MORE:
  __asm {
    mov eax,ecx            // eax <- phi
    dec ebx                // p-1
    mul ebx                // phi *= p-1
    mov ecx,eax            // ecx<-phi
    mov eax,dword ptr n
    xor edx,edx
    inc ebx
    div ebx                // n/p
    mov edi,eax            // n <- n/p
  }
LOOP1:
  __asm {
    mov eax,edi            // eax <- n
    xor edx,edx
    div ebx
//    cmp edx,0              // n%p=0 ?
    or  edx,edx
    jnz WHILE
    mov edi,eax            // n <- n/p
    mov eax,ecx
    mul ebx
    mov ecx,eax            // phi <- phi*p
    jmp LOOP1
  }
WHILE:
  __asm {
    mov dword ptr phi,ecx
    cmp edi,1              // n=1 ?
    jz  END
    mov dword ptr n,edi
    jmp DO                 // do same thing for next divisor
  }

END:
  return phi ;
}
