//
//  Copyright (C) 1993 by S.Tomabechi
//  All rights reserved
//
//  real cubic root by Newton's method
//
//  C 1998/05/19
//       Ver 2.2 ȍ~ł́AL>ȉ̌ łKv͂Ȃ
//                         ȑO̔ł̌`FbNcĂ.
//
//       VC++ V5.0 ł pow(x,y)  x>0 ^ĂȂƓ{̂łɑΉ
//                      CũoO
//
#include "Fint.hpp"
#include <math.h>
#include "Error.hpp"

Fint cubrt(const Fint& x)
{
  int  xfDigit=x.fdigit() ;
  long tlen=len(x) ;

  if( tlen==0 ) return x ;

  long flen=32*xfDigit ;
  long k=tlen-flen ;
  long l ;
  long shift ;
  if( k<0 ) {
    l=(-k)/3 ;
    shift=0 ;
  }
  else {
    shift=(k-1)/96 ;           // 96=3*32

    l=k-96*shift ;
    if( l>32 ) {
      l=(99-l)/3 ;
      shift++ ;
    }
    else l=0 ;
  }
  Fint a=x<<(3*l) ;

  a.fDigit+=3*shift ;

// ̃`FbNVer2.2 ł͂łɕKvȂ
//  if( a.fDigit>=a.nDigit ) Error( fDigit>nDigit ) ;

  int t=3 ;
  Fint u(xfDigit+1+t,xfDigit+t) ;
  Fint s ;

#ifdef __BORLANDC__
  u=1.0/powl((long double)a,1.0/3) ;    // long double ŋߎ
#else
//  long double tld=1.0/powl((long double)a,1.0/3) ;
  long double tld ;
  if( a>=0 ) tld=1.0/powl((long double)a,1.0/3) ;
  else       tld=-1.0/powl(-(long double)a,1.0/3) ;
  u=tld ;
#endif
  for(;;) {             // ƁA[v邩 ?
    s.isSquare(u) ;
    s.isMulF(s,u) ;
    s.isMulF(s,a) ;
    (++(~s))/=3UL ;
    if( s.nDigit<t ) break ;
    else { s*=u ; u+=s ; }
  }

  s.isSquare(u) ;
  s.isMulF(s,a) ;
  if( k<0 ) s>>=l ;
  else s<<=(-l+32*shift) ;
  return s.isRound(s,xfDigit) ;
}

