//
//	Copyright (C) by S.Tomabechi 1993,1995
//	All rights reserved.
//
//	calculate power
//
//	DO NOT calculate power as a^n=exp(n*log(a))
//
#include "Fint.hpp"
#include "MintFunc.hpp"
#include "FintFunc.hpp"

Fint power(const Fint& x,const Mint& n)
{
  Mint::_Mtemp=n ;
						 // x^n=(1/x)^(-n)
  if( Mint::_Mtemp.isNegative() ) {
	Fint::_Ftemp=1/x ;
  }
  else Fint::_Ftemp=x ;

  Fint y(x.fdigit()+1,x.fdigit()) ;
  y=1 ;
  long leng=ilog2(n) ;
  unsigned long d ;
  long j(0),k ;

  if( leng>=0 ) for(;;) {
	d=Mint::_Mtemp.digit[j++] ;
	for( k=32 ; k!=0 ; k-- ) {
	  if( d&1 ) y*=Fint::_Ftemp ;	 // y *= x
	  if( --leng<0 ) goto RET ;
	  d>>=1 ;						   // n /= 2
	  Fint::_Ftemp*=Fint::_Ftemp ;	 // x *= x
	}
  }
RET:
  return y ;

}



Fint power(const Mint& n,const Fint& f)
{
#ifdef __BORLANDC__
  if( sign(f)<0 ) return 1/power(n,-f) ;
#else
  if( sign(f)<0 ) return Mint(1)/power(n,-f) ;
#endif

  Mint Ipart=Int(f) ;		  // separate integer part and fractional part
  Fint fn(n) ;
  fn[f.fdigit()-fn.fdigit()] ;
  return exp((f-Ipart)*log(fn))*power(n,(unsigned long)Ipart) ;
}

Fint power(const Fint& x,const Fint& f)
{
#ifdef __BORLANDC__
  if( sign(f)<0 ) return 1/power(x,-f) ;
#else
  if( sign(f)<0 ) return Mint(1)/power(x,-f) ;
#endif

  Mint Ipart=Int(f) ;
  return exp((f-Ipart)*log(x))*power(x,Ipart) ;
}


Fint power(const Fint& x,const unsigned long n)
{
//	Mint::_Mtemp=n ;
						 // x^n=(1/x)^(-n)
  Fint::_Ftemp=x ;


  Fint y(x.fdigit()+1,x.fdigit()) ;
  y=1 ;
  unsigned long nn(n) ;
//	long leng=ilog2(n) ;
//	long j(0),k ;

  for( ; nn!=0 ;  ) {
	if( nn&1 ) y*=Fint::_Ftemp ;	// y *= x
//	  if( --leng<0 ) goto RET ;
	nn>>=1 ;						  // n /= 2
	Fint::_Ftemp*=Fint::_Ftemp ;   // x *= x
  }
RET:
  return y ;

}

Fint power(const Fint& x,const long n)	  // power
{
#if 0
  return n>=0 ? power(x,(unsigned long)n):power(Fint::_Ftemp.isDiv(1,x),(unsigned long)(-n)) ;
#else
	if( n>=0 ) {
		return power(x,(unsigned long)n) ;
	}
	else {
		return power(Fint::_Ftemp.isDiv((unsigned long)1,x),(unsigned long)(-n)) ;
	}
#endif
}

