//
//  Copyright (C) by S.Tomabechi 1994,1995,1996
//  All rights reserved.
//
//  return number k such that 2^k<=n<2^(k+1)
//  return -1 when n=0
//  e.g.
//   ilog2(0)=-1
//   ilog2(1)=0
//   ilog2(2)=1
//   ilog2(3)=2
//   ilog2(2^n)=n
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

long ilog2(const Mint& n)
{
#ifndef  __BORLANDC__
  long leng ;
#endif
  __asm {
    mov   esi,n
#ifdef __BORLANDC__
    mov   eax,[esi.nDigit]
    mov   esi,[esi]
#else
    mov   eax,[esi+NDIGIT]
    mov   esi,[esi]
#endif
  }
  __asm {
    dec   eax
    js    Zero            // case n=0
    bsr   ecx,[eax*NBYTE+esi]
    shl   eax,5          // *32
    add   eax,ecx
  }
Zero:
#ifdef __BORLANDC__
  return _EAX ;
#else
  __asm mov leng,eax
  return leng ;
#endif
}

