//
//  Copyright (C) by S.Tomabechi 1997
//  ALl rights reserved.
//
//  IEEE `wAA̒l𒊏oD邢̓ZbgD
//  1997/01/11 쐬
//
#include "LDbl.hpp"
#ifdef __BORLANDC__
#pragma inline
#endif

#ifdef __BORLANDC__
int LDbl::Sign(void)
{
  int s(-1) ;
  __asm {
    mov eax,this
    mov ax,[eax+8]
    cmp ax,0x8000
    jae RET1
    mov s,1
  }

RET1:
  return s ;
}

int LDbl::Exp(void)
{
  int m ;
  __asm {
    mov   ebx,this
    mov   ax,[ebx+8]
    and   ax,0x7fff
    sub   ax,LDBL_BIAS
    movsx ecx,ax
    mov   m,ecx
  }
  return m ;
}

unsigned long LDbl::Low()
{
  unsigned long n ;
  __asm {
    mov ebx,this
    mov eax,[ebx]
    mov n,eax
  }
  return n ;
}

unsigned long LDbl::High()
{
  unsigned long n ;
  __asm {
    mov ebx,this
    mov eax,[ebx+4]
    mov n,eax

  }
  return n ;
}

bool LDbl::isZero()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    xor eax,eax
    cmp [ebx],eax
    jne RET1
    cmp [ebx+4],eax
    jne RET1
    cmp [ebx+8],ax
    jne RET1
    mov f,1 ;
  }
RET1:
  return f ;
}


void LDbl::SetHigh(unsigned long d)
{
  __asm {
    mov ebx,this
    mov eax,d
    mov [ebx+4],eax
  }
}


void LDbl::SetLow(unsigned long d)
{
  __asm {
    mov ebx,this
    mov eax,d
    mov [ebx],eax
  }
}


void LDbl::SetSign(int s)
{
  __asm {
    mov ebx,this
    mov eax,s
    and ax,0x8000
    mov cx,[ebx+8]
    and cx,0x7fff
    or  cx,ax
    mov [ebx+8],cx
  }
}

void LDbl::SetExp(int e)
{
  __asm {
    mov ebx,this
    mov eax,dword ptr e
    add ax,LDBL_BIAS
    and ax,0x7fff
    mov cx,[ebx+8]
    and cx,0x8000
    or  cx,ax
    mov [ebx+8],cx
  }
}

bool LDbl::isPositiveInfinity()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp word ptr [ebx+8],0x7fff
    jne RET1
    cmp dword ptr [ebx+4],0x80000000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}

bool LDbl::isNegativeInfinity()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp word ptr [ebx+8],0x0fff
    jne RET1
    cmp dword ptr [ebx+4],0xf8000000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}


bool LDbl::isIndefinite()
{
  bool f(false) ;
  __asm {
    mov ebx,this
    cmp word ptr [ebx+8],0x0fff
    jne RET1
    cmp dword ptr [ebx+4],0xfc000000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov f,1
  }
RET1:
  return f ;

}


bool LDbl::isDeNormal()
{
  bool f ;
  __asm {
    mov ebx,this
    mov ax,[ebx+8]
    and ax,0x7fff
    mov byte ptr f,0
//    cmp ax,0
    or   ax,ax
    jnz  RET1
    mov byte ptr f,1
    cmp dword ptr [ebx+4],0
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov byte ptr f,0
  }
RET1:
  return f ;

}
#endif
/***********

#else


int LDbl::Sign(void)
{
  int s(-1) ;
  __asm {
    mov eax,dword ptr [this]
    mov eax,dword ptr [eax+4]
    cmp eax,0x80000000
    jae RET1
    mov dword ptr [s],1
  }

RET1:
  return s ;
}

int LDbl::Exp(void)
{
  int m ;
  __asm {
    mov eax,dword ptr [this]
    mov eax,dword ptr [eax+4]
    and eax,0x7ff00000
    shr eax,20
    sub eax,LDBL_BIAS
    mov dword ptr [m],eax
  }
  return m ;
}

unsigned long LDbl::Low()
{
  unsigned long n ;
  __asm {
    mov eax,dword ptr [this]
    mov eax,dword ptr [eax]
    shl eax,12
    mov dword ptr [n],eax
  }
  return n ;
}

unsigned long LDbl::High()
{
  unsigned long n ;
  __asm {
    mov ebx,dword ptr [this]
    mov ecx,dword ptr [ebx]
    shr ecx,20
    and ecx,0x00000fff

    mov edx,dword ptr [ebx+4]
    and edx,0x000fffff
    shl edx,12
    or  edx,ecx

    mov dword ptr [n],edx
  }
  return n ;
}



void LDbl::SetHigh(unsigned long d)
{
  __asm {
    mov ebx,dword ptr [this]
    mov ecx,dword ptr [ebx+4]
    and ecx,0xfff00000
    mov eax,dword ptr [d]
    shr eax,12
    or  ecx,eax
    mov dword ptr [ebx+4],ecx

    mov ecx,dword ptr [ebx]
    and ecx,0x000fffff
    mov eax,dword ptr [d]
    shl eax,20
    or  ecx,eax
    mov dword ptr [ebx],ecx
  }
}


void LDbl::SetLow(unsigned long d)
{
  __asm {
    mov ebx,dword ptr [this]
    mov eax,dword ptr [ebx]
    and eax,0xfff00000
    mov ecx,dword ptr [d]
    shr ecx,12
    or  ecx,eax
    mov dword ptr [ebx],ecx
  }
}


void LDbl::SetSign(int s)
{
  __asm {
    mov ebx,dword ptr [this]
    mov eax,dword ptr [s]
    and eax,0x80000000
    mov ecx,dword ptr [ebx+4]
    and ecx,0x7fffffff
    or  ecx,eax
    mov dword ptr [ebx+4],ecx
  }
}

void LDbl::SetExp(int e)
{
  __asm {
    mov ebx,dword ptr [this]
    mov eax,dword ptr [e]
    add eax,LDBL_BIAS
    shl eax,20
    and eax,0x7ff00000
    mov ecx,dword ptr [ebx+4]
    and ecx,0x800fffff
    or  ecx,eax
    mov dword ptr [ebx+4],ecx
  }
}


bool LDbl::IsZero()
{
  bool f(false) ;
  __asm {
    mov ebx,dword ptr [this]
    cmp dword ptr [ebx+4],0
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov dword ptr [f],1
  }
RET1:
  return f ;

}

bool LDbl::IsPositiveInfinity()
{
  bool f(false) ;
  __asm {
    mov ebx,dword ptr [this]
    cmp dword ptr [ebx+4],0x7ff00000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov dword ptr [f],1
  }
RET1:
  return f ;

}

bool LDbl::IsNegativeInfinity()
{
  bool f(false) ;
  __asm {
    mov ebx,dword ptr [this]
    cmp dword ptr [ebx+4],0x0ff00000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov dword ptr [f],1
  }
RET1:
  return f ;

}


bool LDbl::IsIndefinite()
{
  bool f(false) ;
  __asm {
    mov ebx,dword ptr [this]
    cmp dword ptr [ebx+4],0x0fff80000
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov dword ptr [f],1
  }
RET1:
  return f ;

}


bool LDbl::IsDeNormal()
{
  bool f ;
  __asm {
    mov ebx,dword ptr [this]
    mov eax,dword ptr [ebx+4]
    and eax,0x7ff00000
    mov dword ptr [f],0
//    cmp eax,0
    or  eax,eax
    jnz RET1
    mov dword ptr [f],1
    cmp dword ptr [ebx+4],0
    jne RET1
    cmp dword ptr [ebx],0
    jne RET1
    mov dword ptr [f],0
  }
RET1:
  return f ;

}

#endif

*********/
