//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//  logical sum
//
#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#ifdef __BORLANDC__
#pragma inline            // TASM ɂRpCw
#endif
#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isOR(const Mint& a,const Mint& b)
{

  int shift(a.fDigit-b.fDigit) ;

  if( shift<0 ) {             // swap a and b to avoid recurcive call 1995.07.15
    __asm {
      mov   eax,a
      xchg  eax,b
      mov   a,eax
      neg   shift
    }
  }

  int anDigit(a.nDigit) ;
  int bnDigit(b.nDigit+shift) ;
  int min_a_b=anDigit<bnDigit ? anDigit:bnDigit ;
  min_a_b=(min_a_b>shift ? min_a_b:shift) ;
  int max_a_b=anDigit>bnDigit ? anDigit:bnDigit ;
  int max_min=max_a_b-min_a_b ;
  bool same=(this==&a) ;
  unsigned long* v ;
                                // b ̔z̐擪AhXo
  if( this==&b) {               // b ߂lƓ
    (Mint::_vMtemp=b).fDigit=0 ;    // b Rs[
    v=Mint::_vMtemp.digit ;
  }
  else v=b.digit ;              // AhXo

  if( ndim()<max_a_b ) {        // a߂\ȑ傫Ȃ ?
    if( same ) reallocate(max_a_b) ;  // TCY傫
    else allocate(max_a_b) ;
  }

  __asm {
    mov   edi,this
    mov   esi,a
#ifdef __BORLANDC__
    mov   eax,max_a_b
    mov   [edi.nDigit],eax
    mov   eax,[esi.fDigit]
    mov   [edi.fDigit],eax
    mov   al,[esi.nDim+3]
    mov   [edi.nDim+3],al

    mov   edi,[edi]
    mov   esi,[esi]
#else
    mov   eax,max_a_b
    mov   dword ptr [edi+NDIGIT],eax
    mov   eax,dword ptr [esi+FDIGIT]
    mov   dword ptr [edi+FDIGIT],eax
    mov   al,byte ptr [esi+SIGN]
    mov   byte ptr [edi+SIGN],al

    mov   edi,dword ptr [edi]         // di=offset of digit
    mov   esi,dword ptr [esi]         // si=offset of a.digit
#endif
    mov   ecx,shift
    jecxz SetZero
    cmp   same,0
    jne   SetZero
    cmp   ecx,anDigit
    jbe   Copy
    mov   ecx,anDigit
    jecxz SetZero
  }
Copy:                         // aɊ֗^ȂRs[
  __asm {
    mov   eax,[ecx*NBYTE+esi-NBYTE]
    mov   [ecx*NBYTE+edi-NBYTE],eax
    dec   ecx
    jnz   Copy
  }
SetZero:                      // a ̌傫NA[
  __asm {
    mov   ecx,shift
    mov   edx,anDigit
    sub   ecx,edx
    jbe   pre_Loop1
  }
More:                         // a ̌傫NA
  __asm {
    mov   dword ptr [edx*NBYTE+edi],0
    inc   edx
    dec   ecx
    jnz   More
  }
pre_Loop1:                    // a  b̃I[obv镔̘a
  __asm {                       // ߂
    mov   ebx,v                  // bx=offset of b.digit
    mov   eax,shift
    lea   edi,[edi+eax*NBYTE]
    lea   esi,[esi+eax*NBYTE]
    xor   edx,edx
    mov   ecx,min_a_b
    sub   ecx,shift
    jng   skip1
    cmp   same,1       // a Ɩ߂l͓ ?
    je    addself                // a Ɩ߂lꍇ ʏ
  }
Loop1:                        // digit[j+shift]=a.digit[j+shift]+b.digit[j]
  __asm {
    mov eax,[edx*NBYTE+esi]    // eax=a.digit[j+shift]
    or  eax,[edx*NBYTE+ebx] // a.digit[j+shift]+b.digit[j]
    mov [edx*NBYTE+edi],eax
                    // digit[j+shift]=a.digit[j+shift]+b.digit[j]
    inc   edx
    dec   ecx
    jnz   Loop1                 // ܂ׂ
    jmp   skip1
  }
addself:                      // this==&a ̏ꍇ̕ʏ
  __asm {                       // ʏ͂ȂĂIs͂.
    mov   esi,ebx                 // ͍̏̂߂̂łāA
    xor   edx,edx                 // ꂪȂƍIȂ߂ł͂Ȃ.
  }
loop11:                       // digit[j+shift] += b.digit[j]
  __asm {
    mov eax,[edx*NBYTE+esi]
    or  [edx*NBYTE+edi],eax
    inc  edx
    dec  ecx
    jnz loop11
    mov esi,edi
  }
skip1:
  __asm {
    mov ecx,anDigit     // č̑傫,thisɉ
    cmp ecx,bnDigit
    jge set_flag        // a ̌̕傫
    mov esi,ebx
  }
set_flag:
  __asm {               // ۑ carry flag 𕜊
    mov   ecx,max_min   // č
    jecxz OVERFLOW      // č͂Ȃ
  }
LOOP2:
  __asm {               // č
    mov eax,[edx*NBYTE+esi] // a.digit[j]
    mov [edx*NBYTE+edi],eax  // digit[j]=eax
    inc edx
    dec ecx
    jnz LOOP2
  }

OVERFLOW:
ZERO:
  __asm {
    mov  esi,this
#ifdef __BORLANDC__
    cmp dword ptr [esi.nDigit],0
#else
    cmp dword ptr [esi+NDIGIT],0
#endif
    jne RET1
#ifdef __BORLANDC__
    mov byte ptr [esi.nDim+3],1
    mov edi,[esi]
#else
    mov byte ptr [esi+SIGN],1
    mov edi,dword ptr [esi]
#endif
    mov dword ptr [edi],0
  }
RET1:
  return *this ;
}

