//
//  Copyright (C) 1994 by S.Tomabechi.
//  All rights reserved.
//
//  returns n-th prime 
//
//  this program is fast up to 8400000 primes but slow over 8400000 primes 
//                    
//  n Ԗڂ̑fԂ
//   n ɂ
//  20000 ܂ł͑̂Ƃ͒x
//  HvKvD
//
//  2000/07/25  
//  8400000 ܂ł͍ɂȂ悤ɏC
//  ۂ̓e[ug
//
//  prm(    0)=1
//  prm(    1)=2
//  prm( 1000)=7919
//  prm( 5000)=48611
//  prm(10000)=104729
//  prm(15000)=163841
//  prm(20000)=224737
//
//

#ifdef __BORLANDC__
#pragma inline
#endif


extern const unsigned long _primes[] ;
extern const unsigned long _Nprimes_ ;
extern const unsigned long _Ninterval_ ;
extern const unsigned long _Nprimeinc_ ;
extern const unsigned char _t_[] ;
extern const unsigned char _small_prime_[] ;

unsigned long prm(const unsigned long n)
{

  __asm {                             // search index by binary search where n is. 
                                                                 
    mov   eax,n
    mov   edi,[_Ninterval_] 
    cmp   eax,[_Nprimes_]             // n>=Nprimes
    jae   FIND                        // n is not in table 
  }
PRE_LOOP:
  __asm {
    mov   ecx,[_Nprimeinc_]           // fix ecx = _Nprimeinc_

    xor   esi,esi
    xor   ebx,ebx
  }
LOOP:
  __asm {
    mov   ebx,esi
    add   ebx,edi
    shr   ebx,1                 // bx=(si+di)/2
    mov   eax,ecx
    mul   ebx
    cmp   eax,n                 // in left-side
    ja    Set_di
    add   eax,ecx
    cmp   eax,n                 // in right-side
    jbe   Set_si
    mov   edi,ebx
    jmp   FIND
  }
Set_si:
  __asm {
    mov   esi,ebx
    jmp   LOOP
  }
Set_di:
  __asm {
    mov   edi,ebx
    jmp   LOOP
  }
FIND:
  __asm {
    or    edi,edi
    jnz   notZero
    mov   ebx,n
    cmp   ebx,5               // treate primes 2,3,5,7,11 by another way 
    ja    Initial
    or    ebx,ebx
    jnz   Set_small_prime
    mov   ecx,1
    jmp   RET1
  }
Set_small_prime:
  __asm {
    dec   ebx
    movzx ecx,byte ptr [_small_prime_+ebx]

    jmp   RET1
  }
Initial:
  __asm {
    sub   n,5
    mov   ecx,11
    mov   edi,ecx
    jmp   Search
  }
notZero:
  __asm {
    mov   eax,edi
    mov   edx,[_Nprimeinc_]
    mul   edx

    sub   n,eax
    mov eax,[_primes+edi*4]

    mov   edi,eax
    sub   eax,11
    mov   ebx,210
    xor   edx,edx
    div   ebx
    mul   ebx
    add   eax,11
    mov   ecx,eax    // ecx <-> p
  }
Search:
  __asm {
    mov   esi,47
  }
SearchLoop:
  __asm {
    cmp   ecx,edi
    jae   EXIT
    inc   esi
    cmp   si,48
    jb    SKIP      
    xor   esi,esi     
  }
SKIP:
  __asm {
    movzx eax,byte ptr [_t_+esi]

    add   ecx,eax
    jmp   SearchLoop
  }
EXIT:
  __asm {
    cmp   n,0
    jne   LOOP0
    jmp   RET1
  }


LOOP0:                        // generate primes in order 
  __asm {                     // check whether ebx is primes 

    inc   esi           
    cmp   si,48
    jne   SKIP2
    xor   esi,esi
  }
SKIP2:
  __asm {
    movzx edx,byte ptr [_t_+esi]

    add   ecx,edx

    mov   eax,ecx               // divide by 3 
    xor   edx,edx               // here ebx>11
    mov   ebx,3                 
    div   ebx
    or    edx,edx
    jz    LOOP0

    mov   eax,ecx               // divide by 5 
    xor   edx,edx
    mov   ebx,5
    div   ebx
    or    edx,edx
    jz    LOOP0

    mov   eax,ecx               // divide by 7 
    xor   edx,edx
    mov   ebx,7
    div   ebx
    or    edx,edx
    jz    LOOP0

    mov   eax,ecx               // divide by 11 
    xor   edx,edx
    mov   ebx,11
    div   ebx
    or    edx,edx
    jz    LOOP0

    mov   edi,47
    mov   ebx,11
  }
LOOP1:
  __asm {                     // divide by the primes which are greater than 13 
    inc   edi
    cmp   edi,48
    jne   SKIP1
    xor   edi,edi
  }
SKIP1:
  __asm {
    movzx edx,byte ptr [_t_+edi]

    add   ebx,edx
    mov   eax,ecx
    xor   edx,edx
    div   ebx          // Ă݂
    cmp   eax,ebx      //  <  ?
    jb    PRIME        // f
    or    edx,edx
    jnz   LOOP1        // ̈Œׂ
    jmp   LOOP0        // ؂ꂽ
  }
PRIME:
  __asm {
    dec   n
    jz    RET1
    jmp   LOOP0
  }
RET1:
  __asm mov n,ecx
  return n ;
}

