//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  primitive root s.t. < q > = (Z/pZ)^*
//
//  f̌n( primitive root ) ߂
//
//  p : f ( ̊֐ł, fǂׂȂ )
//  ߂l g : g^(p-1)=1 mod p 𖞂 g
//             g^n!=1 mod p for n<p-1
//  2 珇ɂ̈ʐ𒲂ׂPȕ@
//
#ifdef __BORLANDC__
#pragma inline
#endif

unsigned long prmroot(const unsigned long p)
{
  __asm {
    mov ebx,p      // ebx=p
    mov p,1
    cmp ebx,2      // p=2 ?
    je  RET1
    mov edi,1      // g=1
    mov eax,edi    // w=1
  }
RETRY:
  __asm{
    inc edi        // g++
    mov ecx,ebx    // ecx <- p
    sub ecx,2      // number of loop2
  }
LOOP1:
  __asm {          // i=1 to i=p-2
    xor edx,edx
    mul edi        // w*g
    div ebx        // %p 
    mov eax,edx    // w=(w*g)%p
    cmp eax,1      // unit  ?
    je  RETRY      // not primitive root i.e. order!=p-1 
    dec ecx
    jnz LOOP1      
    mov p,edi      // g^n!=1 mod p for n<p-1 
  }
RET1:
  return p ;
}
