//
//  Copyright (C) by S.Tomabechi 1996
//  All rights reserved.
//
//  Partition-exchange sort ( so called quick-sort )
//
//  long _size   (I) number of records
//  long _length (I) size of a record (byte)  (must be multiple of 2)
//  long pos     (I) offset of key in record (byte)
//  long* record (I) address of array of records
//
//  L[ unsigned short ł郌R[hz~Ƀ\[g
//  C ̃Cu quick sort  10{炢͑
//
//  ̃\[g stable łȂ
//
//  long _size   (I) R[ȟ
//  long _length (I) R[h̑傫 (byte) 2 ̔{ł邱
//  long pos     (I) L[̈ʒu. 擪̃ItZbg (byte)
//  long* record (I) R[hz̐擪AhX
//
#ifdef __BORLANDC__
#pragma inline
#endif
extern long _stack_[] ;
void QSortUSD(const long _size,const long _length,const long pos,
              unsigned short* record)
{
  long r,l(0) ;
  long M(8) ;
  long index ;
  long istack(0) ;
  long i,j ;
  unsigned short key ;

  __asm {
    dec  _size                // R[ȟ
    cmp  _size,0
    jle  RET1
    mov  eax,_size
    mul  _length              // size of one record (byte)
    mov  r,eax

    mov  eax,M                // use Insert Sort when size is less than M
    mul  _length
    mov  M,eax

    mov  esi,record           // front address of records

    mov  edi,esi
    add  edi,pos              // comparison at offset pos

  }

MAIN_LOOP:
  __asm {
    mov eax,r
    sub eax,l
    cmp eax,M                 //  (r-l)<M ?
    jge STAGE1

//    cmp eax,0
    or   eax,eax
    jle  POP_STACK0

    mov eax,l                 // straight insertion sort
    add eax,_length
    mov index,eax
  }
LOOP1:
  __asm {
    mov  ebx,index
    mov  esi,record
    mov  ecx,_length
  }
MOVE:
  __asm {
    push word ptr [ebx+esi]
    add  esi,2
    sub  ecx,2
    jnz  MOVE
  }

  __asm {
    mov  dx,[ebx+edi]   // ebx=k
    mov  key,dx
    sub  ebx,_length
  }
LOOP2:
  __asm {

      cmp  dx,[ebx+edi]   // eax=k-1
      jbe  NEXT_LOOP

      mov  eax,ebx
      add  eax,_length
      mov  ecx,_length
      mov  esi,record
  }
MORE:
  __asm {
      mov  dx,[ebx+esi]
      mov  [eax+esi],dx
      add  esi,2
      sub  ecx,2
      jnz  MORE
      mov  dx,key
 }
//NEXT:
  __asm {
      sub  ebx,_length
      cmp  ebx,l
      jge  LOOP2
  }
NEXT_LOOP:
  __asm {
    mov  ecx,_length
    mov  esi,record
    add  ebx,_length
    add  esi,_length
  }
MOVE2:
  __asm {
    sub  esi,2
    pop  word ptr [ebx+esi]
    sub  ecx,2
    jnz  MOVE2
  }
  __asm {
    mov  ebx,index
    add  ebx,_length
    mov  index,ebx
    cmp  ebx,r
    jbe  LOOP1

  }
POP_STACK0:
  __asm {
   mov ebx,istack
//   cmp ebx,0
   or  ebx,ebx
   jg  POP_STACK
   jmp RET1                    // stop if stack is empty
 }
POP_STACK:
  __asm {
   mov eax,[_stack_+ebx-4]
   mov r,eax

   mov eax,[_stack_+ebx-8]
   mov l,eax

   sub ebx,8

   mov istack,ebx
   jmp MAIN_LOOP


  }
STAGE1:
    __asm {
      mov eax,r                         // right side
      add eax,l
      xor edx,edx
      div _length
      shr eax,1
      mul _length
      mov ebx,eax                       // ebx=(r+l)/2
      mov eax,l
      add eax,_length                    // eax=l+1
      mov esi,record
      mov ecx,_length
    }
C1:
      __asm {             // swap record[(l+r)/2] <-> record[l+1]
        mov  dx,[ebx+esi]
        xchg [eax+esi],dx
        mov  [ebx+esi],dx
        add  esi,2
        sub  ecx,2
        jnz  C1

        mov  ebx,r                    // ebx=r
        mov  dx,[ebx+edi]   // edx=key[r]
        cmp  [eax+edi],dx   // key[l+1] > key[r] ?
        jae  N1
        mov  esi,record
        mov  ecx,_length
      }
C2:
      __asm {             // swap record
        mov  dx,[ebx+esi]
        xchg [eax+esi],dx
        mov  [ebx+esi],dx
        add  esi,2
        sub  ecx,2
        jnz  C2
      }
N1:
      __asm {
        sub  eax,_length              // eax=l

        mov  dx,[ebx+edi]   // edx=key[r]
        cmp  [eax+edi],dx   // key[l]>key[r]
        jae  N2
        mov  esi,record
        mov  ecx,_length
      }
C3:
      __asm {                         // swap record[l] <-> record[r]
        mov  dx,[ebx+esi]
        xchg [eax+esi],dx
        mov  [ebx+esi],dx
        add  esi,2
        sub  ecx,2
        jnz  C3
      }
N2:
      __asm {
        mov  ebx,eax
        add  ebx,_length              // ebx=l+1
        mov  dx,[ebx+edi]   // edx=key[l+1]
        cmp  dx,[eax+edi]   // key[l+1]>key[l]
        jae  N3
        mov  esi,record
        mov  ecx,_length
      }
C4:
      __asm {
        mov  dx,[ebx+esi]
        xchg [eax+esi],dx
        mov  [ebx+esi],dx
        add  esi,2
        sub  ecx,2
        jnz  C4

      }
N3:
    __asm {
      mov i,ebx                       // i=l+1
      mov dx,[eax+edi]      // edx=key[l]
      mov key,dx
      mov ebx,eax                     // ebx=l
      mov eax,r
      mov j,eax                       // j=r
      mov esi,record
      mov ecx,_length
    }
MOVE4:
    __asm {
      push word ptr [ebx+esi]
      add  ebx,2
      sub  ecx,2
      jnz  MOVE4
    }
SEARCH:
    __asm {
       mov dx,key
       mov eax,i
    }
SEARCH1:
      __asm {
        add eax,_length                // search position where key[i]>=key
        cmp dx,[eax+edi]
        jb  SEARCH1
      }
      __asm {
        mov i,eax

        mov eax,j
      }
SEARCH2:
      __asm {
        sub eax,_length
        cmp dx,[eax+edi]
        ja  SEARCH2
      }
      __asm {
        mov j,eax

        cmp eax,i             // exit loop if j<i
        jl  LEAVE_LOOP

        mov esi,record
        mov ecx,_length
        mov ebx,i
      }                        // Swap record[i]<->record[j]
C5:
      __asm {
        mov  dx,[ebx+esi]
        xchg [eax+esi],dx
        mov  [ebx+esi],dx
        add  esi,2
        sub  ecx,2
        jnz  C5

        jmp  SEARCH
      }


LEAVE_LOOP:
    __asm {
        mov  esi,record
        mov  ecx,_length
        mov  ebx,l
        mov  eax,j
      }
C6:
      __asm {                             // record[l]=record[j]
        mov  dx,[eax+esi]
//        xchg word ptr [eax+esi],dx
        mov  [ebx+esi],dx
        add  esi,2
        sub  ecx,2
        jnz  C6
    }

    __asm {
      mov  esi,record
      add  esi,_length
      mov  ecx,_length
      mov  ebx,j
    }
MOVE5:                                  // record[j] <- paritioning element
    __asm {
      sub  esi,2
      pop  word ptr [ebx+esi]
      sub  ecx,2
      jnz  MOVE5
    }
    __asm {
      add istack,8
      mov ebx,istack
//cmp ebx,64*4
//jg ERROR
      mov eax,r
      add eax,_length
      sub eax,i                 // r-i+1

      mov edx,j
      sub edx,l                 // j-l

      cmp eax,edx
      jl  ELSE_
      mov eax,r
      mov [_stack_+ebx-4],eax    // push r
      mov eax,i
      mov [_stack_+ebx-8],eax    // push i
      mov eax,j
      sub eax,_length
      mov r,eax        // r=j-1
      jmp MAIN_LOOP

    }
ELSE_:
    __asm {
      mov eax,j
      sub eax,_length
      mov [_stack_+ebx-4],eax     // push j-1
      mov eax,l
      mov [_stack_+ebx-8],eax     // push l
      mov eax,i
      mov l,eax                              // l=i
      jmp MAIN_LOOP
    }

RET1:
return ;
//ERROR: ;
//cout << "stack overflow " ;
}