//
//  Copyright (C) by S.Tomabechi 2000
//  All rights reserved.
//
//  Partition-exchange sort ( so called quick-sort )
//
//  long _size   (I) number of records
//  long _length (I) size of a record (byte)  (must be multiple of 4)
//  long pos1    (I) offset of 1-st key in record (byte)
//  long pos2    (I) offset of 2-nd key in record (byte)
//  long pos3    (I) offset of 3-rd key in record (byte)
//  long pos4    (I) offset of 4-th key in record (byte)
//  long* record (I) address of array of records
//
//
//  L[ unsigned long Ŏl̃L[R[hzɃ\[g
//
//  long _size   (I) R[ȟ
//  long _length (I) R[h̑傫 (byte) 4 ̔{ł邱
//  long pos1    (I) L[̈ʒu. 擪̃ItZbg (byte)
//  long pos2    (I) L[̈ʒu
//  long pos3    (I) OL[̈ʒu
//  long pos4    (I) lL[̈ʒu
//  long* record (I) R[hz̐擪AhX
//
//  NFS  4 large primes Ήpɍ쐬
//

#include <iostream.h>
#ifdef __BORLANDC__
#pragma inline
#endif
extern long _stack_[] ;

void QSortUL4A(const long _size,const long _length,
              const long pos1,const long pos2,const long pos3,const long pos4,
              unsigned long* record)
{
  long r,l(0) ;
  long M(8) ;
  long index ;
  long istack(0) ;
  long ipos2 ;
  long ipos3 ;
  long ipos4 ;
  long key,key2,i,j ;
  long key3,key4 ;
  long ipos1 ;

  __asm {
    dec  _size
    cmp  _size,0
    jle  RET1
    mov  eax,_size
    mul  _length
    mov  r,eax

    mov  eax,M
    mul  _length
    mov  M,eax

    mov  esi,record           // R|h̐擪AhX

    mov  edi,esi
    add  edi,pos4             // rƂ pos1 炵Ƃ
    mov  ipos4,edi            // Ԗڂ̃L[̈ʒu

    mov  edi,esi
    add  edi,pos3             // rƂ pos1 炵Ƃ
    mov  ipos3,edi            // Ԗڂ̃L[̈ʒu

    mov  edi,esi
    add  edi,pos2
    mov  ipos2,edi            // Ԗڂ̃L[Ɉʒu

    mov  edi,esi
    add  edi,pos1             // rƂ pos1 炵Ƃ
    mov  ipos1,edi            // Ԗڂ̃L[̈ʒu
  }

MAIN_LOOP:
  __asm {
    mov eax,r
    sub eax,l
    cmp eax,M                 //  (r-l)<M ?
    jge STAGE1

    cmp eax,0
    jle POP_STACK

    mov eax,l                 // straight insertion sort
    add eax,_length
    mov index,eax
  }
LOOP1:
  __asm {
    mov  ebx,index
    mov  esi,record
    mov  ecx,_length
  }
MOVE:
  __asm {
    push dword ptr [ebx+esi]
    add  esi,4
    sub  ecx,4
    jnz  MOVE
  }

  __asm {

    mov  edi,ipos4
    mov  ecx,[ebx+edi]
    mov  key4,ecx

    mov  edi,ipos3
    mov  ecx,[ebx+edi]
    mov  key3,ecx

    mov  edi,ipos2
    mov  ecx,[ebx+edi]
    mov  key2,ecx

    mov  edi,ipos1
    mov  edx,[ebx+edi]  // ebx=k
    mov  key,edx

    sub  ebx,_length
  }
LOOP2:
  __asm {
//mov    edi,ipos1
      cmp  edx,[ebx+edi]      // eax=k-1
      ja   NEXT_LOOP
      jb   SKIP1

//mov  ecx,key2
      mov  edi,ipos2
      cmp  ecx,[ebx+edi]
      ja   NEXT_LOOP
      jb   SKIP1

      mov  ecx,key3
      mov  edi,ipos3
      cmp  ecx,[ebx+edi]
      ja   NEXT_LOOP
      jb   SKIP1

      mov  ecx,key4
      mov  edi,ipos4
      cmp  ecx,[ebx+edi]
      ja   NEXT_LOOP

  }
SKIP1:
  __asm {

      mov  eax,ebx
      add  eax,_length
      mov  ecx,_length
      mov  esi,record
  }
MORE:
  __asm {
      mov  edx,[ebx+esi]
      mov  [eax+esi],edx
      add  esi,4
      sub  ecx,4
      jnz  MORE
      mov  edx,key
      mov  ecx,key2
      mov  edi,ipos1
 }
//NEXT:
  __asm {
      sub  ebx,_length
//    mov  edi,ipos1
      cmp  ebx,l
      jge  LOOP2
  }
NEXT_LOOP:
  __asm {
    mov  ecx,_length
    mov  esi,record
    add  ebx,_length
    add  esi,_length
  }
MOVE2:
  __asm {
    sub  esi,4
    pop  dword ptr [ebx+esi]
    sub  ecx,4
    jnz  MOVE2
  }
  __asm {
    mov  ebx,index
    add  ebx,_length
    mov  index,ebx
    cmp  ebx,r
    jbe  LOOP1


  }
//POP_STACK0:
  __asm {
   mov ebx,istack
   cmp ebx,0
   jg  POP_STACK
   jmp RET1                   // X^bNȂ̂ŏI
 }
POP_STACK:
  __asm {
   mov eax,[_stack_+ebx-4]
   mov r,eax

   mov eax,[_stack_+ebx-8]
   mov l,eax

   sub ebx,8

   mov istack,ebx
   jmp MAIN_LOOP


   }
STAGE1:
    __asm {
      mov eax,r                         // E
      add eax,l
      xor edx,edx
      div _length
      shr eax,1
      mul _length
      mov ebx,eax                       // ebx=(r+l)/2
      mov eax,l
      add eax,_length                    // eax=l+1
      mov esi,record
      mov ecx,_length
    }
C1:
      __asm {             // swap record[(l+r)/2] <-> record[l+1]
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C1

        mov  ebx,r                      // ebx=r
        mov  edi,ipos1                  // key1
        mov  edx,[ebx+edi]  // edx=key[r]
        cmp  [eax+edi],edx  // key[l+1] > key[r] ?
//        jle   N1
        jb   N1
        ja   SKIP2

        mov  edi,ipos2
        mov  edx,[ebx+edi]
        cmp  [eax+edi],edx
        jb  N1
        ja  SKIP2

        mov  edi,ipos3
        mov  edx,[ebx+edi]
        cmp  [eax+edi],edx
        jb  N1
        ja  SKIP2

        mov  edi,ipos4
        mov  edx,[ebx+edi]
        cmp  [eax+edi],edx
        jbe  N1

      }
SKIP2:
      __asm {
        mov  esi,record
        mov  ecx,_length
      }
C2:
      __asm {             // swap record
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C2
      }
N1:
      __asm {
        sub  eax,_length                  // eax=l

        mov  edi,ipos1
        mov  edx,[ebx+edi]   // edx=key[r]
        cmp  [eax+edi],edx   // key[l]>key[r]
        jb   N2
        ja   SKIP3

        mov  edi,ipos2
        mov  edx,[ebx+edi]
        cmp  [eax+edi],edx
        jb   N2
        ja   SKIP3

        mov  edi,ipos3
        mov  edx,[ebx+edi]
        cmp  [eax+edi],edx
        jb   N2
        ja   SKIP3

        mov  edi,ipos4
        mov  edx,[ebx+edi]
        cmp  [eax+edi],edx
        jbe  N2
      }
SKIP3:
      __asm {
        mov  esi,record
        mov  ecx,_length
      }
C3:
      __asm {                            // swap record[l] <-> record[r]
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C3
      }
N2:
      __asm {
        mov  ebx,eax                     // eax=l
        add  ebx,_length                 // ebx=l+1

        mov  edi,ipos1
        mov  edx,[ebx+edi]  // edx=key[l+1]
        cmp  edx,[eax+edi]  // key[l+1]>key[l]
        jb   N3
        ja   SKIP4

        mov  edi,ipos2
        mov  edx,[ebx+edi]  // edx=key[l+1]
        cmp  edx,[eax+edi]  // key[l+1]>key[l]
        jb   N3
        ja   SKIP4

        mov  edi,ipos3
        mov  edx,[ebx+edi]  // edx=key[l+1]
        cmp  edx,[eax+edi]  // key[l+1]>key[l]
        jb   N3
        ja   SKIP4


        mov  edi,ipos4
        mov  edx,[ebx+edi]
        cmp  edx,[eax+edi]
        jbe  N3
      }
SKIP4:
      __asm {
        mov  esi,record
        mov  ecx,_length
      }
C4:
      __asm {
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C4

      }
N3:
    __asm {
      mov i,ebx         // i=l+1


      mov edi,ipos4
      mov edx,[eax+edi]
      mov key4,edx

      mov edi,ipos3
      mov edx,[eax+edi]
      mov key3,edx

      mov edi,ipos2
      mov edx,[eax+edi]
      mov key2,edx

      mov edi,ipos1
      mov edx,[eax+edi] // edx=key[l]
      mov key,edx

      mov ebx,eax       // ebx=l
      mov eax,r
      mov j,eax     // j=r
      mov esi,record
      mov ecx,_length
    }
MOVE4:
    __asm {
      push dword ptr [ebx+esi]
      add  ebx,4
      sub  ecx,4
      jnz  MOVE4
    }
SEARCH:
    __asm {
       mov edx,key
       mov ecx,key2
       mov edi,ipos1
       mov ebx,ipos2
       mov eax,i
    }
SEARCH1:
      __asm {
        add eax,_length                // key[i]>=key ƂȂʒuT
        cmp edx,[eax+edi]
        ja  SEARCH1
        jb  SKIP5

        mov ecx,key2
        mov ebx,ipos2
        cmp ecx,[eax+ebx]
        ja  SEARCH1
        jb  SKIP5

        mov ecx,key3
        mov ebx,ipos3
        cmp ecx,[eax+ebx]
        ja  SEARCH1
        jb  SKIP5

        mov ecx,key4
        mov ebx,ipos4
        cmp ecx,[eax+ebx]
        ja  SEARCH1


      }
SKIP5:
      __asm {
        mov i,eax

        mov eax,j
      }
SEARCH2:
      __asm {
        sub eax,_length
        cmp edx,[eax+edi]
        jb  SEARCH2
        ja  SKIP6


        mov ecx,key2
        mov ebx,ipos2
        cmp ecx,[eax+ebx]
        jb  SEARCH2
        ja  SKIP6

        mov ecx,key3
        mov ebx,ipos3
        cmp ecx,[eax+ebx]
        jb  SEARCH2
        ja  SKIP6

        mov ecx,key4
        mov ebx,ipos4
        cmp ecx,[eax+ebx]
        jb  SEARCH2
      }
SKIP6:
      __asm {
        mov j,eax

        cmp eax,i   // j<i Ȃ烋[v甲
        jb  LEAVE_LOOP

        mov esi,record
        mov ecx,_length
        mov ebx,i
      }                        // Swap record[i]<->record[j]
C5:
      __asm {
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C5

        jmp  SEARCH
      }

LEAVE_LOOP:
    __asm {
        mov  esi,record
        mov  ecx,_length
        mov  ebx,l
        mov  eax,j
      }
C6:
      __asm {                             // record[l]=record[j]
        mov  edx,[eax+esi]
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C6
    }

    __asm {
      mov  esi,record
      add  esi,_length
      mov  ecx,_length
      mov  ebx,j
    }
MOVE5:                                  // record[j] <- paritioning element
    __asm {
      sub  esi,4
      pop  dword ptr [ebx+esi]
      sub  ecx,4
      jnz  MOVE5
    }
    __asm {
      add istack,8
      mov ebx,istack
cmp ebx,64*4
jg ERROR
      mov eax,r
      add eax,_length
      sub eax,i                 // r-i+1

      mov edx,j
      sub edx,l                 // j-l

      cmp eax,edx
      jb  ELSE_
      mov eax,r
      mov [_stack_+ebx-4],eax     // push r
      mov eax,i
      mov [_stack_+ebx-8],eax     // push i
      mov eax,j
      sub eax,_length
      mov r,eax        // r=j-1
      jmp MAIN_LOOP

    }
ELSE_:
    __asm {
      mov eax,j
      sub eax,_length
      mov [_stack_+ebx-4],eax      // push j-1
      mov eax,l
      mov [_stack_+ebx-8],eax      // push l
      mov eax,i
      mov l,eax                              // l=i
      jmp MAIN_LOOP
    }

RET1:
return ;
ERROR: ;
//cout << "stack overflow " << istack;
}
