//
//	Copyright (C) by S.Tomabechi  1994,1995,1997
//	All rights reserved.
//
//	shift bits to right by given n
//
//	E n rbgVtg (2^n Ŋ)
//
//	n : VtgrbgA32ȏł悢
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isShiftr(const Mint& a,const long n)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
#endif
  int anDigit ;

  if( n==0 ) return *this=a ;  // do nothing

  __asm {
	mov  esi,a
#ifdef __BORLANDC__
	mov  ebx,[esi.nDigit]
#else
	mov  ebx,[esi+NDIGIT]
#endif
	mov  anDigit,ebx

	mov  edi,this
	cmp  esi,edi
	je	 EXEC
#ifdef __BORLANDC__
	mov  eax,[edi.nDim]
#else
	mov  eax,[edi+NDIM]
#endif
	and  eax,_DIGITS_
	cmp  ebx,eax					 // #digits < size of array ?
	jbe  EXEC
  }

  allocate(anDigit) ;				// enlarge array

  __asm {

	mov   esi,a
	mov   ebx,anDigit
  }
EXEC:
  __asm {
	or	  ebx,ebx				   // a=0 ?
	jz	  Zero

	dec   ebx					   // calculate length of a as bit string
#ifdef __BORLANDC__
	mov   edx,[esi] 				// a.digit
#else
	mov   edx,[esi]
#endif
	bsr   ecx,[ebx*NBYTE+edx]	  // position of non zero bit

#if 0
	jnz FIND_NONZERO_BIT
	xor ecx,ecx
  }

FIND_NONZERO_BIT:
  __asm {
#endif

	shl   ebx,5
	add   ebx,ecx		// length of a as bit string

	sub   ebx,n 		// length after shifting
	jl	  Zero

	mov   edi,this

	shr   ebx,5
	inc   ebx
#ifdef __BORLANDC__
	mov   [edi.nDigit],ebx
	mov   eax,[esi.fDigit]
	mov   [edi.fDigit],eax
	mov   al,[esi.nDim+3]	  // signature
	mov   [edi.nDim+3],al

	mov   esi,[esi]
	mov   edi,[edi]
#else
	mov   [edi+NDIGIT],ebx
	mov   eax,[esi+FDIGIT]
	mov   [edi+FDIGIT],eax
	mov   al,[esi+SIGN]
	mov   [edi+SIGN],al

	mov   esi,[esi]
	mov   edi,[edi]
#endif
	mov   ecx,n
	mov   eax,ecx
	shr   eax,5
	lea   esi,[esi+eax*NBYTE]

	and   ecx,0x0000001f			// cl <- n%32
	mov   ebx,anDigit
	sub   ebx,eax
	mov   eax,[esi]
	or	  ebx,ebx
	jz	  EXIT
  }
LOOP_SHIFT:
  __asm {
	dec   ebx
	jz	  EXIT
	mov   edx,eax
	lea   esi,[esi+NBYTE]
	mov   eax,[esi]
	shrd  edx,eax,cl
	mov   [edi],edx
	lea   edi,[edi+NBYTE]
	jmp   LOOP_SHIFT
  }
EXIT:
  __asm {
	shr   eax,cl
	mov   [edi],eax
	jmp   RET1
  }

Zero:						  // result is zero
  __asm {
	mov   edi,this
#ifdef __BORLANDC__
	mov   byte ptr [edi.nDim+3],1
	mov   ebx,[esi.fDigit]
	mov   [edi.fDigit],ebx
	mov   dword ptr [edi.nDigit],0
#else
	mov   byte ptr [edi+SIGN],1
	mov   ebx,[esi+FDIGIT]
	mov   [edi+FDIGIT],ebx
	mov   dword ptr [edi+NDIGIT],0
#endif
  }

RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

