//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//  exclusive logical sum
//
//  rI_a
//
#ifdef __BORLANDC__
#pragma inline
#pragma option -wsig-
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isXOR(const Mint& a,const Mint& b)
{

  int shift(a.fDigit-b.fDigit) ;

  if( shift<0 ) {             //
    __asm {                   // exchange a and b
      mov  eax,a
      xchg eax,b
      mov  a,eax

      neg  shift
    }
  }

  int anDigit(a.nDigit) ;
  int bnDigit(b.nDigit+shift) ;
  int min_a_b=anDigit<bnDigit ? anDigit:bnDigit ;
  min_a_b=(min_a_b>shift ? min_a_b:shift) ;
  int max_a_b=anDigit>bnDigit ? anDigit:bnDigit ;
  int max_min=max_a_b-min_a_b ;
  bool same=(this==&a) ;
  unsigned long* v ;
                                  // copy  b.digit
  if( this==&b) {                 // this=&b
    (Mint::_vMtemp=b).fDigit=0 ;  // copy b
    v=Mint::_vMtemp.digit ;
  }
  else v=b.digit ;

  if( ndim()<max_a_b ) {        // memory is not sufficient. enlarge array
    if( same ) reallocate(max_a_b) ;
    else allocate(max_a_b) ;
  }

  __asm {
    mov   edi,this
    mov   esi,a

#ifdef __BORLANDC__
    mov   eax,max_a_b
    mov   [edi.nDigit],eax
    mov   eax,[esi.fDigit]
    mov   [edi.fDigit],eax
    mov   al,[esi.nDim+3]
    mov   [edi.nDim+3],al

    mov   edi,[edi]
    mov   esi,[esi]
#else
    mov   eax,max_a_b
    mov   [edi+NDIGIT],eax
    mov   eax,[esi+FDIGIT]
    mov   [edi+FDIGIT],eax
    mov   al,byte ptr [esi+SIGN]
    mov   byte ptr [edi+SIGN],al

    mov   edi,[edi]
    mov   esi,[esi]
#endif
    mov   ecx,shift
    jecxz SetZero
    cmp   same,0
    jne   SetZero
    cmp   ecx,anDigit
    jbe   Copy
    jecxz SetZero
  }
Copy:
  __asm {
    mov   eax,[ecx*NBYTE+esi-NBYTE]
    mov   [ecx*NBYTE+edi-NBYTE],eax
    dec   ecx
    jnz   Copy
  }
SetZero:
  __asm {
    mov   ecx,shift
    mov   edx,anDigit
    sub   ecx,edx
    jbe   pre_loop1           // b>a  ?
  }
more:                         // clear digits which are greater thab a
  __asm {
    mov   dword ptr [edx*NBYTE+edi],0
    inc   edx
    dec   ecx
    jnz   more
  }
pre_loop1:
  __asm {

    mov   ebx,v                  // ebx=offset of b.digit
    mov   eax,shift

    lea   edi,[edi+eax*NBYTE]
    lea   esi,[esi+eax*NBYTE]
    xor   edx,edx
    mov   ecx,min_a_b
    sub   ecx,shift
    jng   skip1
    cmp   same,1       // this=&a ?
    je    addself
  }
loop1:                        // digit[j+shift]=a.digit[j+shift]+b.digit[j]
  __asm {
    mov eax,[edx*NBYTE+esi]    // eax=a.digit[j+shift]
    xor eax,[edx*NBYTE+ebx] // a.digit[j+shift]+b.digit[j]
    mov [edx*NBYTE+edi],eax
        // digit[j+shift]=a.digit[j+shift]+b.digit[j]
    inc   edx
    dec   ecx
    jnz   loop1
    jmp   skip1
  }
addself:                      // in case this==&a
  __asm {
    mov   esi,ebx
    xor   edx,edx
  }
loop11:                       // digit[j+shift] ^= b.digit[j]
  __asm {
    mov   eax,[edx*NBYTE+esi]
    xor   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   loop11
    mov   esi,edi
  }
skip1:
  __asm {
    mov   ecx,anDigit
    cmp   ecx,bnDigit
    jge   set_flag
    mov   esi,ebx
  }
set_flag:
  __asm {                     // resstore carry flag
    mov  ecx,max_min
    jecxz Overflow
  }
loop2:
  __asm {
    mov   eax,[edx*NBYTE+esi]  // eax=a.digit[j]
    mov   [edx*NBYTE+edi],eax  // digit[j]=eax
    inc   edx
    dec   ecx
    jnz   loop2
  }
Overflow:
  __asm {
    mov   edi,this
#ifdef __BORLANDC__
  mov   esi,[edi]
#else
  mov   esi,dword ptr [edi+DIGIT]
#endif

  }

  __asm {
    mov   ecx,max_a_b
    jecxz ZERO
    xor   eax,eax
  }
SearchNonZero:                       // LZbg
  __asm {
    cmp   dword ptr [ecx*NBYTE+esi-NBYTE],eax   // 0 ?
    jne   SET_DIGIT             // 0 łȂŏʌ
    dec   ecx
    jnz   SearchNonZero
  }
ZERO:                     // 0 łȂ͂ȂDZʂ́A0 낤.
  __asm {
#ifdef __BORLANDC__
    mov byte ptr [edi.nDim+3],1
#else
    mov byte ptr [edi+SIGN],1
#endif
  }
SET_DIGIT:
  __asm {
#ifdef __BORLANDC__
  mov [edi.nDigit],ecx   // cx ͗L
#else
  mov [edi+NDIGIT],ecx   // cx ͗L
#endif
  }

//RET:
  return *this ;
}

