//
//	Copyright (C) by S.Tomabechi 1999
//	All rights reserved.
//
//	return the nearest integer from rational number a/b
//

#include "Mint.hpp"

Mint nearInt(const Mint& a,const Mint& b)
{
  Mint q,r ;
  Mint bb ;
  int s ;
  bb=b ;
  divide(a,b,q,r) ;
  if( sign(b)<0 ) {
	 ~r ;
	 ~bb ;
  }
  s=sign(r) ;
  if( s==0 ) ;				 // quotient is a rational integer
  else if( s<0 ) {			 // negative rational number
	r+=bb ;
	if( bb-r<r ) ;
	else {
		if( sign(a)>=0 ) q++ ;
		else q-- ;
	}
  }
  else {
	if( bb-r<=r ) {
		if( sign(a)>=0 ) q++ ;
		else q-- ;
	}
  }
  return q ;
}


Mint floorInt(const Mint& a,const Mint& b)
{
  Mint q,r ;
  int sa,sb ;

  divide(a,b,q,r) ;
  sa=sign(a) ;
  sb=sign(b) ;
  if( sa>0 ) {
	if( sb<0 && sign(r)!=0 ) q-- ;
  }
  else if( sa<0 ) {
	if( sb<0 ) ;
	else if( sign(r)!=0 ) q-- ;
  }
  return q ;
}

#if 0
void main(void)
{
  Mint a,b,q ;
  a=0 ;
  b=1 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=0 ;
  b=-1 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=1 ;
  b=2 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=1 ;
  b=-2 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=3 ;
  b=4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=3 ;
  b=-4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=-3 ;
  b=-4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=-3 ;
  b=4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=-1 ;
  b=2 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=-1 ;
  b=4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=-1 ;
  b=-4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=1 ;
  b=4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
  a=1 ;
  b=-4 ;
  cout << endl <<"a b a/b " << a << " " << b << " " << nearInt(a,b) ;
}

#endif
