//
//  Copyright (C) by S.Tomabechi 2000
//  All rights reserved.
//
//  calulate remainders of integer N for given primes
//

#include "Mint.hpp"
// ndivisor!=0 Ȃ ndivisor ̈ʒufqݒ
void negate_tbl(unsigned long nentry,unsigned short* ptbl,unsigned long* rtbl);

// rtbl  rtblx ŋʂ̏]fzɓĕԂ
void common_divisor(unsigned long nentry,
                        unsigned short* ptbl,
                        unsigned long* rtbl,
                        unsigned long* rtblx,
                        unsigned long& ndivisor,
                        unsigned long* divisors)
{
//  unsigned long p(0) ;
    unsigned long count(0) ;
    __asm {
        mov esi,ptbl
        mov edi,rtblx
        mov edx,rtbl
        xor ecx,ecx   // p=0 
//      mov ecx,p
//      mov eax,ndivisor
        mov eax,ndivisor
        mov eax,[eax]
        mov ebx,divisors
        lea ebx,[ebx+4*eax]
//      mov [eax],ebx
    }
NEXT_PRM:
    __asm {
        movzx eax,word ptr [esi]
        add   ecx,eax           // p+=difference 
        mov   eax,[edi]
        cmp   eax,[edx]
        jne   SKIP
        mov   [ebx],ecx         // stack prime
        lea   ebx,[ebx+4]
        inc   count
    }   
SKIP:
    __asm {     
        lea   esi,[esi+2] 
        lea   edi,[edi+4] 
        lea   edx,[edx+4] 
        dec   nentry
        jnz   NEXT_PRM
        
        mov   eax,count
        mov   ebx,ndivisor
        add   [ebx],eax
    }   
}                       
void divisor(unsigned long nentry,
            unsigned short* ptbl,
            unsigned long* rtbl,
            unsigned long res,
            unsigned long& ndivisor,
            unsigned long* divisors)
{
    unsigned long p ;
    __asm {
        mov   esi,ptbl
        mov   edi,rtbl
        xor   ebx,ebx
        mov   ecx,ndivisor
    //    mov   [ecx],0

        movzx eax,word ptr [esi]
        mov   p,eax
        mov   eax,[edi]
        sub   eax,res
        and   eax,1
        jz    FOUND
        inc   ebx
    }
LOOP1:
    __asm {
        movzx eax,word ptr [esi+2*ebx]
        add   p,eax
        mov   eax,[edi+4*ebx]
        cmp   eax,res
        jne   NOT_FOUND
    }
FOUND:
    __asm {

        mov   edx,[ecx]
        mov   eax,divisors
        lea   edx,[4*edx+eax]
        mov   eax,p
        mov   [edx],eax
        inc   [ecx]

    }

NOT_FOUND:
    __asm {
        inc ebx
        cmp ebx,nentry
        jb  LOOP1
    }
}

//
//  N       (I) : integer
//  nentry  (I) : number of primes
//  ptbl    (I) : table of primes (difference)
//  rtbl    (O) : table of remainders
//
void residueTable(Mint& N,
                unsigned long nentry,
                unsigned short* ptbl,     // difference of primes ( 2 bytes )
                unsigned long* rtbl)
{
  unsigned long p(0) ;
  unsigned long ndigit ;
  unsigned long save_nentry ;

 __asm {

    mov ebx,nentry
    mov save_nentry,ebx

    mov esi,N
#ifdef __BORLANDC__
    mov ecx,[esi.nDigit]
#else
    mov ecx,[esi+NDIGIT]
#endif
    dec ecx
    js  ALL_ZERO
    mov ndigit,ecx

    mov ebx,ptbl
    mov esi,[esi]        // N.ndigit
    mov edi,rtbl
  }
LOOP_ON_PRIME:
  __asm {

    dec nentry
    js  END

    movzx eax,word ptr [ebx]
    add p,eax

    mov ecx,ndigit
    xor edx,edx
  }
DIV_LOOP:
  __asm {
    mov eax,[esi+NBYTE*ecx]
    div p
    dec ecx
    jns DIV_LOOP

    mov [edi],edx
    lea edi,[edi+4]
    lea ebx,[ebx+2]

    jmp LOOP_ON_PRIME

  }

ALL_ZERO:
END:
  if( sign(N)<0 ) negate_tbl(save_nentry,ptbl,rtbl) ;

RET1:
}


void negate_tbl(unsigned long nentry,unsigned short* ptbl,unsigned long* rtbl)
{
  __asm {
    mov ecx,nentry
    xor ebx,ebx
    mov esi,ptbl
    mov edi,rtbl
  }
NEGATIVE:
  __asm {
    movzx eax,word ptr [esi]
    add   ebx,eax                    // DO NOT CHANGE ebx
    mov   edx,[edi]
    or    edx,edx                    // is zero ?
    jz    NEXT_PRIME
    mov   eax,ebx
    sub   eax,edx                    // prime - residue
    mov   [edi],eax
  }
NEXT_PRIME:
  __asm {
    lea edi,[edi+4]
    lea esi,[esi+2]
    dec ecx
    jnz NEGATIVE
  }

}


void make_prmtbl(unsigned long tblMax,unsigned short* ptbl,unsigned long q=0)
{
    unsigned long p ;
    unsigned long j ;
//    q=0 ;
    for( j=0 ; j<tblMax ; j++ ) {
        p=nextprm(q) ;
        ptbl[j]=(unsigned short)(p-q) ;
        q=p ;
    }
}


#include "Error.hpp"
#if 0
int main(void)
{
    unsigned short* ptbl ;
    unsigned long* rtbl ;
    unsigned long tblMax=10000 ;
    unsigned long* divs ;
    unsigned long q1=0,d ;
    unsigned long nd=0 ;
    unsigned long k ;
    Mint N=1 ;
//  N*=2 ;
    N*=3 ;
    N*=5 ;
    N*=7 ;
    N*=11 ;
    N*=13 ;
    N*=17 ;
    N*=101 ;
    N*=919 ;
    N*=19191 ;
    N*=15485863  ;


    ptbl=new unsigned short[tblMax] ;    // prims table
    rtbl=new unsigned long[tblMax] ;     // residue table
    divs=new unsigned long[tblMax] ;     // residue table
/***
    q1=0 ;
    for( k=0 ; k<tblMax ; k++ ) {
        d=q1 ;
        q1=nextprm(q1) ;                 // difference of  primes
        ptbl[k]=(unsigned short)(q1-d) ;
    }
******/
    make_prmtbl(tblMax,ptbl) ;
//    N*=q1 ;
 residueTable(N+1,
              tblMax,
              ptbl,     // difference of primes ( 2 bytes )
              rtbl) ;
    divisor(tblMax,
            ptbl,
            rtbl,
            0,
            nd,
            divs) ;
    for( k=0 ; k<nd ; k++ ) {
        if( (N+1)%divs[k]!=0 ) Error(aaa) ;
        cout << endl << divs[k] ;
    }
    cout << endl ;

    nd=0 ;
    divisor(tblMax,
            ptbl,
            rtbl,
            1,
            nd,
            divs) ;
    for( k=0 ; k<nd ; k++ ) {
        if( (N)%divs[k]!=0 ) Error(bbb) ;
        cout << endl << divs[k] ;
    }
    cout << endl ;
    nd=0 ;
    divisor(tblMax,
            ptbl,
            rtbl,
            2,
            nd,
            divs) ;
    for( k=0 ; k<nd ; k++ ) {
        if( (N-1)%divs[k]!=0 ) Error(ccc) ;
        cout << endl << divs[k] ;
    }

    cout << endl << "N " << N ;
    delete [] ptbl ;
    delete [] rtbl ;
    delete [] divs ;


    return 1 ;
}
#endif
