//
//  Elliptic Curve over Rational Number Field  0.10
//
//  Copyright (C) 2001  by S.Tomabechi
//       All rights reserved
//
//
#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif


#ifndef __EQ_ARITH_HPP
#define __EQ_ARITH_HPP

#include "Mint.hpp"
#ifdef __BORLANDC__
#    pragma warn -lvc
#endif
class ECPt {
public:
    static Mint C ;
    static Mint N ;
    Mint X ;
    Mint Z ;
    Mint sum ;
    Mint dif ;
    Mint sum2 ;
    Mint dif2 ;
    ECPt& operator=(const ECPt& P)
    {
        X=P.X ;
        Z=P.Z ;
        sum=P.sum ;
        dif=P.dif ;
        sum2=P.sum2 ;
        dif2=P.dif2 ;
        return *this ;
    }

    ECPt& doubleh(ECPt& P)
    {
#if 1
        sum.isSub(P.sum2,P.dif2) ;
        X.isMul(P.sum2,P.dif2)%=N ;
        Z=sum*(P.dif2+C*sum)%N ;
        sum.isAdd(X,Z) ;
        dif.isSub(X,Z) ;
        sum2.isSquare(sum)%=N ;
        dif2.isSquare(dif)%=N ;
        return *this ;
#else
        sum=(P.sum2-P.dif2) ;
        X=P.sum2*P.dif2%N ;
        Z=sum*(P.dif2+C*sum)%N ;
        sum=X+Z ;
        dif=X-Z ;
        sum2.isSquare(sum)%=N ;
        dif2.isSquare(dif)%=N ;
        return *this ;
#endif
    }
    ECPt& mulh(Mint& n,ECPt& P) ;

    ECPt& addh(ECPt& P1,ECPt& P2,ECPt& Ps)
    {
//  Mint S,T ;
#if 1
        sum2.isMul(P1.sum,P2.dif)%=N ;   // (X1+Z1)(X2-Z2)
        dif2.isMul(P1.dif,P2.sum)%=N ;   // (X1-Z1)(X2+Z2)
//  Mint U,V ;
//      sum=sum2+dif2 ;     // (S+T) = 2*(X1X2-Z1Z2)
        sum.isAdd(sum2,dif2) ;
//      dif=dif2-sum2 ;     //  (T-s)=2*(X1Z2-X2Z1)
        dif.isSub(dif2,sum2) ;

        (X.isSquare(sum)).isMul(X,Ps.Z)%=N ;
        (Z.isSquare(dif)).isMul(Z,Ps.X)%=N ;
//      Z=dif*dif*Ps.X%N ;
        sum.isAdd(X,Z) ;
//      dif=X-Z ;
        dif.isSub(X,Z) ;
//      sum2=sum*sum%N  ;
        sum2.isSquare(sum)%=N ;
//      dif2=dif*dif%N  ;
        dif2.isSquare(dif)%=N ;
        return *this ;
#else
        sum2=P1.sum*P2.dif%N ;   // (X1+Z1)(X2-Z2)
        dif2=P1.dif*P2.sum%N ;   // (X1-Z1)(X2+Z2)
//  Mint U,V ;
        sum=sum2+dif2 ;     // (S+T) = 2*(X1X2-Z1Z2)
        dif=dif2-sum2 ;     //  (T-s)=2*(X1Z2-X2Z1)

        X=sum*sum*Ps.Z%N ;
        Z=dif*dif*Ps.X%N ;
        sum=X+Z ;
        dif=X-Z ;
        sum2=sum*sum%N  ;
        dif2=dif*dif%N  ;
        return *this ;
#endif
    }


} ;
// (x3,y3,z3)  (x1,y1,z1),(x2,y2,z2) ƈقȂĂ邱
void doubleh(Mint& C,Mint& N,
Mint& X,Mint& Z,Mint& X2,Mint& Z2);
void mulh(Mint& C,Mint& N,Mint& n,
          Mint& X,Mint& Z,Mint& NX,Mint& NZ) ;

void addh(Mint& C,Mint& N,
        Mint& X1,Mint& Z1,
        Mint& X2,Mint& Z2,
        Mint& Xs,Mint& Zs,
        Mint& Xa,Mint& Za) ;

void add(Mint& a,Mint& b,Mint& N,
    Mint& x1,Mint& y1,Mint& z1,
    Mint& x2,Mint& y2,Mint& z2,
    Mint& x3,Mint& y3,Mint& z3) ;

//(X2,Y2,Z2)  (X,Y,Z) Ɠłǂ
void doubleP(Mint& a,Mint& b,Mint& N,
    Mint& X,Mint& Y,Mint& Z,
    Mint& X2,Mint& Y2,Mint& Z2) ;

// (x3,y3,z3)  (x1,y1,z1),(x2,y2,z2) Ɠł悢
void addP(Mint& a,Mint& b,Mint& N,
    Mint& X1,Mint& Y1,Mint& Z1,
    Mint& X2,Mint& Y2,Mint& Z2,
    Mint& X3,Mint& Y3,Mint& Z3) ;

inline
void subP(Mint& a,Mint& b,Mint& N,
    Mint& X1,Mint& Y1,Mint& Z1,
    Mint& X2,Mint& Y2,Mint& Z2,
    Mint& X3,Mint& Y3,Mint& Z3)
{
    addP(a,b,N,
         X1,Y1,Z1,
         X2,-Y2,Z2,
         X3,Y3,Z3) ;
}


#endif
