//
//  Copyright (C) by S.Tomabechi 2001
//  All rights reserved.
//
//  Sieve Part of SIQS method
//

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "PPMPQS.hpp"
#include "IntFuncs.hpp"
#include "Error.hpp"
extern unsigned long SieveWidth ;
extern unsigned long SieveUnit  ;
//extern unsigned long SieveWidth2 ;
//extern char Cutoff ;

//extern char SieveArray[] ;
extern char lg1[] ;
//extern unsigned long ip[] ;
extern unsigned long pq[] ;
extern unsigned long Cmodp[] ;
extern Mint BS[] ;
#ifdef SIQS_DEBUG
extern unsigned long hoge ;
#endif


#if 1
void SieveInit(unsigned long ncomb,unsigned long nPrimes,
        PPrimes* Primes,
        unsigned long* Bmodp,
        Mint& b,Mint& c
        )
{
    unsigned long a ;
#ifdef SIQS_DEBUG
    unsigned long k(0) ;
#endif
    unsigned long Mmodp ;
    unsigned long r ;
    unsigned long v3,t3 ;
    unsigned long cmodp ;

    __asm {
        mov edi,2               // f
        mov esi,Primes      // fe[ũAhX
        add esi,40
        sub nPrimes,2
        add Bmodp,4
    }
MAIN_LOOP:
    __asm {
        movzx eax,word ptr [esi]    // f̍
        add   edi,eax
        dec   nPrimes
        js    RET

//      inc   q_index
        add Bmodp,4
//#ifdef LINEAR_SIEVE
        mov dl,byte ptr [esi.dmy]       // p | a  ?
        or  dl,dl
#ifndef LINEAR_SIEVE
        jz  OK
#endif
//      mov edx,ecx

#ifdef LINEAR_SIEVE
        jnz EXECUTE

                                // case a=0 mod p
        mov  ebx,c              // compute -c/b i.e. root of bx+c=0
        mov  ecx,[ebx.nDigit]
        mov  ebx,[ebx.digit]
        dec  ecx
        xor edx,edx
    }
DIV_C:
    __asm {
        mov eax,[ebx+4*ecx]
        div edi
        dec ecx
        jns DIV_C

        mov ebx,c
        cmp dword ptr [ebx.nDim],0
        jle NEG_C
        sub edx,edi                     // c-p
        neg edx                         // p-c
    }
NEG_C:
    __asm {
//      sub edx,edi
//      neg edx

#ifdef SIQS_DEBUG

        mov ecx,k
        mov [Cmodp+4*ecx],edx
        mov [hoge],edx
#endif
        mov cmodp,edx

//      inc  k                  // remove q from sieve primes

        mov ebx,b
        mov ecx,[ebx.nDigit]
        mov ebx,[ebx.digit]
        dec ecx
        xor edx,edx
    }

DIV_B2:
    __asm {
        mov eax,[ebx+4*ecx]
        div edi
        dec ecx
        jns DIV_B2

        mov ebx,b
        cmp [ebx.nDim],0
        jge POS_B
        sub edx,edi
        neg edx
    }
POS_B:
    __asm {
        shl edx,1
        sub edx,edi
        jnc OK_B
        add edx,edi
    }
OK_B:
    __asm {
        mov eax,edx
    }



SET_PARM2:
    __asm {

        xor ebx,ebx                     // compute b^-1 mod p

        mov   v3,edi
        mov   ecx,1                         // ecx is inverse
        mov   eax,edx
      }
DIV12:
    __asm {
        xor   edx,edx
        div   v3                            // a/v3
        mov   t3,edx                        // save residue
        mul   ebx
        sub   ecx,eax                       // ecx -= q*v1
        xchg  ecx,ebx
        mov   eax,t3
        or    eax,eax
        jz    RET12
        xchg  eax,v3
        jmp   DIV12
    }

RET12:
    __asm {
        add ecx,edi
        cmp ecx,edi
        jbe BELOW2
        sub ecx,edi
    }
BELOW2:
    __asm {
//      mov a,ecx       // a= a^-1 mod q
#if 0
        mov ebx,k
        lea ebx,[Cmodp+4*ebx]
        mov eax,[ebx]
#else
        mov eax,cmodp
#endif
        mul ecx                   //-c/b
        div edi
        mov ebx,edx


        mov eax,[SieveWidth]      // SieveWidth%q vZ
        xor edx,edx
        div edi
//      mov Mmodp,edx
        mov [esi+16],edx

        sub ebx,edx
//      sub ebx,edx
        js SET_R22
        sub ebx,edi
    }
SET_R22:
    __asm {

    }
BBBB2:
    __asm {
        add ebx,[SieveUnit]
        mov [esi+8],ebx
        mov [esi+12],ebx

#ifdef SIQS_DEBUG
        inc k
#endif
        lea esi,[esi+20]
        jmp MAIN_LOOP
#endif
    }
EXECUTE:
DIV_B:
    __asm {
        mov ebx,Bmodp
        mov edx,[ebx]

        mov ebx,[esi+4]       //  r^2=N mod q

        sub ebx,edx       // r-bq
        jns SET_Q_R_B
        add ebx,edi        // bq > r
    }
SET_Q_R_B:
    __asm {
        mov ecx,ebx

        mov ebx,[esi+4]       //  ebx=r s.t. r^2=N mod q
        add ebx,edx           // r+bq
        sub ebx,edi
        jnc OK_OK             // q>r+bq
        add ebx,edi
    }
OK_OK:
    __asm {
        sub ebx,edi           //  r+bq-q
        jz SET_R1_R2
        neg ebx               // q-r-bq

    }
SET_R1_R2:
    __asm {

        mov eax,ebx // mul(r1,a^-1,q)
        mul dword ptr [esi+16]
        div edi
        mov ebx,edx

        mov eax,ecx // mul(r2,a^-1,q)
        mul dword ptr [esi+16]
        div edi
        mov ecx,edx

        mov eax,[SieveWidth]      // compute SieveWidth%q 
        xor edx,edx
        div edi
//      mov Mmodp,edx
        mov [esi+16],edx


//      sub ebx,Mmodp
        sub ebx,edx
        js  SET_R2
        sub ebx,edi
    }
SET_R2:
    __asm {
//      sub ecx,Mmodp
        sub ecx,edx
        js  BBBB
        sub ecx,edi

    }
BBBB:
    __asm {
        add ecx,[SieveUnit]
        add ebx,[SieveUnit]
        cmp ebx,ecx
        jge SET_POS
        xchg ebx,ecx

    }
SET_POS:
    __asm {
        mov [esi+8],ebx
        mov [esi+12],ecx

    }
OK:
    __asm {
        lea esi,[esi+20]
        jmp MAIN_LOOP

    }
RET: ;


}

#else
void SieveInit(unsigned long ncomb,unsigned long nPrimes,
        PPrimes* Primes,
        unsigned long* b,
        Mint& B,
        Mint& c
        )
{

    unsigned long q ;
    unsigned long a ;
    unsigned long r ;
    unsigned long r1,r2 ;
    unsigned long bb ;
    unsigned long k=0 ;
    unsigned long j,kk ;
    unsigned long Mmodp ;
    Mint w ;
    q=2 ;
    k=0 ;

    for( j=2 ; j<nPrimes ; j++ ) {
        q+=(unsigned long)(Primes[j].diff) ;
        a=1 ;
        for( kk=0 ; kk<ncomb ; kk++ ) {
            a=isMul(a,pq[k],q) ;
        }
        if( a==0 ) {
            r1=isMul(mod(-c,q),invmodp((2*B)%q,q),q) ;
//          Cmodp[k++]=mod(-c,q) ;
            Primes[j].ainv=mod(-c,q) ;
            if( r1<Mmodp ) r1=r1+q-Mmodp ;
            else r1=r1-Mmodp ;
            r1+=SieveUnit ;
            Primes[j].SievePos[0]=r1 ;
            Primes[j].SievePos[1]=r1 ;
            continue ;
        }
//if( a!=b[j] ) Error(a!=b[j]) ;
        Mmodp=SieveWidth%q ;
        r=Primes[j].Root ;
        a=invmodp(a,q) ;

//      bb=mod(b,q) ;
//bb=b[j] ;
for( w=0,k=0 ; k<ncomb ; k++ ) w+=BS[k] ;
bb=mod(w,q) ;
if( bb!=b[j] ) {
cout << endl << bb << " " << b[j] ;
Error(bb!=b[j] ) ;

}
        r1=isSub(r,bb,q) ;
        r2=(q-isAdd(r,bb,q))%q  ;
        r1=isMul(r1,a,q) ;
        r2=isMul(r2,a,q) ;
        if( r1<Mmodp ) r1=r1+q-Mmodp ;
        else r1=r1-Mmodp ;
        if( r2<Mmodp ) r2=r2+q-Mmodp ;
        else r2=r2-Mmodp ;
        r1+=SieveUnit ;
        r2+=SieveUnit ;

        if( r1>r2 ) {
            Primes[j].SievePos[0]=r1 ;
            Primes[j].SievePos[1]=r2 ;
        }
        else {
            Primes[j].SievePos[0]=r2 ;
            Primes[j].SievePos[1]=r1 ;
        }
        Primes[j].ainv=Mmodp ;
//      a=isMul(a,2,q) ;
//      a<<=1 ;
//      if( a>=q ) a-=q ;    // 2/a
//      Primes[j].ainv=a ;
    }
}

#endif


